/* SPDX-License-Identifier: GPL-2.0 OR Linux-OpenIB */
/*
 * Copyright (c) 2025, NVIDIA CORPORATION & AFFILIATES. All rights reserved
 */

#ifndef _IB_UCAPS_H_
#define _IB_UCAPS_H_

#define UCAP_ENABLED(ucaps, type) (!!((ucaps) & (1U << type)))

enum rdma_user_cap {
	RDMA_UCAP_MLX5_CTRL_LOCAL = 0,
	RDMA_UCAP_MLX5_CTRL_OTHER_VHCA = 1,
	RDMA_UCAP_MAX = 2,
};

void ib_cleanup_ucaps(void);

int ib_create_ucap(enum rdma_user_cap type);

void ib_remove_ucap(enum rdma_user_cap type);

int ib_get_ucaps(int *fds, int fd_count, uint64_t *idx_mask);

#endif /* _IB_UCAPS_H_ */
